
		GET	$.arm.aslib.register
		GET	$.arm.aslib.arthur
		GET	$.arm.aslib.constants
		GET	$.arm.aslib.macros
		GET	^.^.arm.h.aosdriver
		GET	^.^.arm.h.asconst


		AREA	|C$$code|, CODE, READONLY

		EXPORT	lock
		EXPORT	unlock
		EXPORT	dis_irq_cnt
		EXPORT	swi
		EXPORT	get_mmu_parameters
		EXPORT	get_mmu_pagemap
		EXPORT	get_mmu_freepages
		EXPORT	set_mmu_pagemap
		EXPORT	set_mmu_onepage
		EXPORT	get_drivelist
		EXPORT	get_driveinfo
		EXPORT	f_do_devio


;*===========================================================================*
;*				lock					     *
;*===========================================================================*
; PUBLIC void lock();
; Disable CPU interrupts.

lock
		MOV	R2, LK
		SWI	MX_EnterSVC
		TEQP	PC, #FIRQFlag:OR:IRQFlag:OR:SVCMode
		LDR	R0, dis_irq_cnt
		ADDS	R0, R0, #1
		STR	R0, dis_irq_cnt
		MOVGTS	PC, R2			; return if already disabled

		MOV	R0, #IOC_BASE
		LDRB	R1, [R0, #IOC_IRQAMASK]
		STRB	R1, irq_mask1
		LDRB	R1, [R0, #IOC_IRQBMASK]
		STRB	R1, irq_mask2
		LDRB	R1, [R0, #IOC_FIRQMASK]
		STRB	R1, irq_mask3
		MOV	R1, #0			; disable all interrupts
		STRB	R1, [R0, #IOC_IRQAMASK]
		STRB	R1, [R0, #IOC_IRQBMASK]
		STRB	R1, [R0, #IOC_FIRQMASK]
		MOVS	PC, R2

dis_irq_cnt	DCD	-1
irq_mask1	%	1
irq_mask2	%	1
irq_mask3	%	1
		ALIGN


;*===========================================================================*
;*				unlock					     *
;*===========================================================================*
; PUBLIC void unlock();
; Enable CPU interrupts.
;

unlock
		MOV	R2, LK
		SWI	MX_EnterSVC
		TEQP	PC, #FIRQFlag:OR:IRQFlag:OR:SVCMode
		LDR	R0, dis_irq_cnt
		SUBS	R0, R0, #1
		STR	R0, dis_irq_cnt
		MOVGES	PC, R2
		MOV	R0, #IOC_BASE
		LDRB	R1, irq_mask3
		STRB	R1, [R0, #IOC_FIRQMASK]
		LDRB	R1, irq_mask2
		STRB	R1, [R0, #IOC_IRQBMASK]
		LDRB	R1, irq_mask1
		STRB	R1, [R0, #IOC_IRQAMASK]

		MOVS	PC, R2


;*===========================================================================*
;*				swi					     *
;*===========================================================================*
; PUBLIC int swi(number, R0, R1, R2)
; make an swi call
;

swi
		ORR	R0, R0, #&EF000000	; generate swi instruction
		STR	R0, swi_word
		MOV	R0, R1
		MOV	R1, R2
		MOV	R2, R3
swi_word	SWI	0			; actual number is inserted
		MOVS	PC, LK


;*===========================================================================*
;*				get_mmu_parameters			     *
;*===========================================================================*
; PUBLIC void get_mmu_parameters(struct mmu_parameters *mmu);
; Get Memory Management Unit Parameters
;

get_mmu_parameters
		SWI	MX_GetParameters
		MOVS	PC, LK


;*===========================================================================*
;*				get_mmu_pagemap				     *
;*===========================================================================*
; PUBLIC void get_mmu_pagemap(vir_bytes mmu_pagemap[]);
; Get map of all pages (including the ones already used)
;

get_mmu_pagemap
		SWI	MX_GetMemoryMap
		MOVS	PC, LK


;*===========================================================================*
;*				get_mmu_freepages			     *
;*===========================================================================*
; PUBLIC void get_mmu_freepages(int mmu_freepages[]);
; Get map of free pages
;

get_mmu_freepages
		SWI	MX_GetMemoryFreeList
		MOVS	PC, LK


;*===========================================================================*
;*				set_mmu_pagemap				     *
;*===========================================================================*
; PUBLIC void set_mmu_pagemap(vir_bytes mmu_pagemap[], int protection);
; PUBLIC void set_mmu_onepage(phys_pagenum phys_page, int vir_page, int prot);
; Set new pagemapping
;

set_mmu_onepage
		ORR	A2, A2, A1, LSL #16
		STR	A2, onepage
		ADR	A1, onepage
		MOV	A2, A3		; protection
		; fall through!

set_mmu_pagemap
		SWI	MX_SetMemoryMap
		MOVS	PC, LK
onepage		DCD	0
		DCD	-1


;*===========================================================================*
;*				get_drivelist				     *
;*===========================================================================*
; PUBLIC int *get_drivelist();
; liefert einen Pointer auf eine Liste der verfuegbaren Drives,
; abgeschlossen mit -1. Jedes Wort enthaelt in den oberen 16 Bits die
; Drivenummer und in den unteren 16 Bits die Partitionnummer.
;

get_drivelist
		MOV	R0, #-1
		SWI	MX_DiskParms
		MOVS	PC, LK


;*===========================================================================*
;*				get_driveinfo				     *
;*===========================================================================*
; PUBLIC int get_driveinfo(int drive, int partition,
;			   struct drive_parm *driveinfo);
; fuellt die Struktur driveinfo mit den spezifischen Daten fuer das
; angegebene Drive.
; liefert 0 falls ok.
;

get_driveinfo
		SWI	MX_DiskParms
		MOVVC	R0, #0		; ok
		MOVVS	R0, #-1		; error
		MOVS	PC, LK


;*===========================================================================*
;*				f_do_devio				     *
;*===========================================================================*
; PUBLIC int f_do_devio(int rdwt, int drive, int partition,
;			int num_secs, int first_sec, void *bufadr);
; Read/write sectors from/to disk
;

f_do_devio
		MOV	IP, SP
		STMDB	SP!, {V1,V2,FP,IP,LK,PC}^
		SUB	FP, IP, #4
		LDR	R4, [IP, #0*4]
		LDR	R5, [IP, #1*4]
		SWI	MX_DiskIO+XBit
		LDMDB	FP, {V1,V2,FP,SP,PC}^

;macbuf		DCD	macbufptr
;macbufptr	%	MACBUFSIZE__
		ALIGN

		END
