@ -> $.minix.usr.h.aosdriver
@
@ Konstanten fuer den Arthur <--> Minix Operating Sytem Driver
@
@ (C) 29/11/89 Martin Patzel
@


@ SWI - Nummern des Treibers

.set MinixSWIBase,	0x00100000	@ niedrigste MINIX-SWI-Nummer = lowest Minix-SWI-Number
.set MX_SystemCall,	MinixSWIBase+0
.set MX_EnableDriver,	MinixSWIBase+1
.set MX_DisableDriver,	MinixSWIBase+2
.set MX_EnterSVC,	MinixSWIBase+3
.set MX_PutC,	MinixSWIBase+4
.set MX_GetC,	MinixSWIBase+5
.set MX_DiskIO,	MinixSWIBase+6
.set MX_DiskParms,	MinixSWIBase+7
.set MX_SetVector,	MinixSWIBase+8
.set MX_Special,	MinixSWIBase+9
.set MX_GetParameters,	MinixSWIBase+10
.set MX_GetMemoryMap,	MinixSWIBase+11
.set MX_GetMemoryFreeList,	MinixSWIBase+12
.set MX_SetTranslator,	MinixSWIBase+13
.set MX_OSMode,	MinixSWIBase+14
.set MX_SetMemoryMap,	MinixSWIBase+15


@ Vektornummern fuer MX_SetVector (swi_set_vector)

.set SV_ClockVec,	0
.set SV_KeybdVec,	1


@ Funktionsnummern fuer MX_Special (swi_special)

.set SP_SetLeds,	0
.set SP_ReadTimer,	1
.set SP_Reset,	2
.set SP_RealTime,	3


@ Funktionsnummern fuer MX_PutC

.set PC_PutC,	0x00000000
.set PC_MoveTo,	0x01000000
.set PC_Scroll,	0x02000000
.set PC_GetWindow,	0x03000000

.set SCRL_Right,	0
.set SCRL_Left,	1
.set SCRL_Down,	2
.set SCRL_Up,	3

@ Devicenummern fuer den Treiber

.set Flop_Dev,	0
.set Hard_Dev,	1
.set Swap_Dev,	2



@ Struktur fuer Infoblock eines Laufwerks (swi_diskparms)

.set DP_DSize,	0x00	@ Laufwerksgroesse in Byte
.set DP_SSize,	0x04	@ Sektorgroesse in Byte
.set DP_Size,	0x08	@ Groesse dieser Struktur in Byte


@ Struktur fuer System-Parameterblock (get_para)

.set GP_MinPgSize,	0x00	@ minimale Pagegroesse in Bytes
.set GP_MaxPgSize,	0x04	@ maximale Pagegroesse in Bytes
.set GP_ActPgSize,	0x08	@ aktuelle Pagegroesse in Bytes
.set GP_CodPgSize,	0x0C	@ log_2(act_pg_size/min_pg_size)
.set GP_MinPPgNum,	0x10	@ minimale Anzahl physikalischer Pages
.set GP_MaxPPgNum,	0x14	@ maximale Anzahl physikalischer Pages
.set GP_ActPPgNum,	0x18	@ aktuelle Anzahl physikalischer Pages
.set GP_MinLPgNum,	0x1C	@ minimale Anzahl logischer Pages
.set GP_MaxLPgNum,	0x20	@ maximale Anzahl logischer Pages
.set GP_ActLPgNum,	0x24	@ aktuelle Anzahl logischer Pages
.set GP_PhysBase,	0x28	@ Basisadresse der physikalischen Pages
.set GP_PhysEnd,	0x2C	@ Endadresse der physikalischen Pages (ausschl.)
.set GP_LogBase,	0x30	@ Basisadresse der logischen Pages
.set GP_LogEnd,	0x34	@ Endadresse der logischen Pages (ausschl.)
.set GP_FreeArea,	0x38	@ Adresse Beginn freier Speicherbereich
.set GP_TopRam,	0x3C	@ Erste Adresse ausserhalb des virt. Adr. Raums
.set GP_Size,	0x40	@ Groesse dieser Struktur in Bytes


		@ END
